<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/hashbrown-0.12.3/src/raw/generic.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>generic.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../hashbrown/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../hashbrown/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../hashbrown/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident"><span class="kw">super</span>::bitmask::BitMask</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::EMPTY</span>;
<span class="kw">use</span> <span class="ident">core</span>::{<span class="ident">mem</span>, <span class="ident">ptr</span>};

<span class="comment">// Use the native word size as the group size. Using a 64-bit group size on</span>
<span class="comment">// a 32-bit architecture will just end up being more expensive because</span>
<span class="comment">// shifts and multiplies will need to be emulated.</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">any</span>(
    <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>,
    <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;aarch64&quot;</span>,
    <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>,
    <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>,
))]</span>
<span class="kw">type</span> <span class="ident">GroupWord</span> <span class="op">=</span> <span class="ident">u64</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
    <span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;32&quot;</span>,
    <span class="ident">not</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;aarch64&quot;</span>),
    <span class="ident">not</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;x86_64&quot;</span>),
    <span class="ident">not</span>(<span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;wasm32&quot;</span>),
))]</span>
<span class="kw">type</span> <span class="ident">GroupWord</span> <span class="op">=</span> <span class="ident">u32</span>;

<span class="kw">pub</span> <span class="kw">type</span> <span class="ident">BitMaskWord</span> <span class="op">=</span> <span class="ident">GroupWord</span>;
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">BITMASK_STRIDE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">8</span>;
<span class="comment">// We only care about the highest bit of each byte for the mask.</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::cast_possible_truncation</span>, <span class="ident">clippy::unnecessary_cast</span>)]</span>
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">BITMASK_MASK</span>: <span class="ident">BitMaskWord</span> <span class="op">=</span> <span class="number">0x8080_8080_8080_8080_u64</span> <span class="kw">as</span> <span class="ident">GroupWord</span>;

<span class="doccomment">/// Helper function to replicate a byte across a `GroupWord`.</span>
<span class="attribute">#[<span class="ident">inline</span>]</span>
<span class="kw">fn</span> <span class="ident">repeat</span>(<span class="ident">byte</span>: <span class="ident">u8</span>) -&gt; <span class="ident">GroupWord</span> {
    <span class="ident">GroupWord::from_ne_bytes</span>([<span class="ident">byte</span>; <span class="ident">Group::WIDTH</span>])
}

<span class="doccomment">/// Abstraction over a group of control bytes which can be scanned in</span>
<span class="doccomment">/// parallel.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This implementation uses a word-sized integer.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Group</span>(<span class="ident">GroupWord</span>);

<span class="comment">// We perform all operations in the native endianness, and convert to</span>
<span class="comment">// little-endian just before creating a BitMask. The can potentially</span>
<span class="comment">// enable the compiler to eliminate unnecessary byte swaps if we are</span>
<span class="comment">// only checking whether a BitMask is empty.</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::use_self</span>)]</span>
<span class="kw">impl</span> <span class="ident">Group</span> {
    <span class="doccomment">/// Number of bytes in the group.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">WIDTH</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span>();

    <span class="doccomment">/// Returns a full group of empty bytes, suitable for use as the initial</span>
    <span class="doccomment">/// value for an empty hash table.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is guaranteed to be aligned to the group size.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">static_empty</span>() -&gt; <span class="kw-2">&amp;</span><span class="lifetime">&#39;static</span> [<span class="ident">u8</span>; <span class="ident">Group::WIDTH</span>] {
        <span class="attribute">#[<span class="ident">repr</span>(<span class="ident">C</span>)]</span>
        <span class="kw">struct</span> <span class="ident">AlignedBytes</span> {
            <span class="ident">_align</span>: [<span class="ident">Group</span>; <span class="number">0</span>],
            <span class="ident">bytes</span>: [<span class="ident">u8</span>; <span class="ident">Group::WIDTH</span>],
        }
        <span class="kw">const</span> <span class="ident">ALIGNED_BYTES</span>: <span class="ident">AlignedBytes</span> <span class="op">=</span> <span class="ident">AlignedBytes</span> {
            <span class="ident">_align</span>: [],
            <span class="ident">bytes</span>: [<span class="ident">EMPTY</span>; <span class="ident">Group::WIDTH</span>],
        };
        <span class="kw-2">&amp;</span><span class="ident">ALIGNED_BYTES</span>.<span class="ident">bytes</span>
    }

    <span class="doccomment">/// Loads a group of bytes starting at the given address.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::cast_ptr_alignment</span>)]</span> <span class="comment">// unaligned load</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">load</span>(<span class="ident">ptr</span>: <span class="kw-2">*const</span> <span class="ident">u8</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">Group</span>(<span class="ident">ptr::read_unaligned</span>(<span class="ident">ptr</span>.<span class="ident">cast</span>()))
    }

    <span class="doccomment">/// Loads a group of bytes starting at the given address, which must be</span>
    <span class="doccomment">/// aligned to `mem::align_of::&lt;Group&gt;()`.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::cast_ptr_alignment</span>)]</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">load_aligned</span>(<span class="ident">ptr</span>: <span class="kw-2">*const</span> <span class="ident">u8</span>) -&gt; <span class="self">Self</span> {
        <span class="comment">// FIXME: use align_offset once it stabilizes</span>
        <span class="macro">debug_assert_eq!</span>(<span class="ident">ptr</span> <span class="kw">as</span> <span class="ident">usize</span> <span class="op">&amp;</span> (<span class="ident">mem::align_of</span>::<span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span>() <span class="op">-</span> <span class="number">1</span>), <span class="number">0</span>);
        <span class="ident">Group</span>(<span class="ident">ptr::read</span>(<span class="ident">ptr</span>.<span class="ident">cast</span>()))
    }

    <span class="doccomment">/// Stores the group of bytes to the given address, which must be</span>
    <span class="doccomment">/// aligned to `mem::align_of::&lt;Group&gt;()`.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">clippy::cast_ptr_alignment</span>)]</span>
    <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">store_aligned</span>(<span class="self">self</span>, <span class="ident">ptr</span>: <span class="kw-2">*mut</span> <span class="ident">u8</span>) {
        <span class="comment">// FIXME: use align_offset once it stabilizes</span>
        <span class="macro">debug_assert_eq!</span>(<span class="ident">ptr</span> <span class="kw">as</span> <span class="ident">usize</span> <span class="op">&amp;</span> (<span class="ident">mem::align_of</span>::<span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span>() <span class="op">-</span> <span class="number">1</span>), <span class="number">0</span>);
        <span class="ident">ptr::write</span>(<span class="ident">ptr</span>.<span class="ident">cast</span>(), <span class="self">self</span>.<span class="number">0</span>);
    }

    <span class="doccomment">/// Returns a `BitMask` indicating all bytes in the group which *may*</span>
    <span class="doccomment">/// have the given value.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This function may return a false positive in certain cases where</span>
    <span class="doccomment">/// the byte in the group differs from the searched value only in its</span>
    <span class="doccomment">/// lowest bit. This is fine because:</span>
    <span class="doccomment">/// - This never happens for `EMPTY` and `DELETED`, only full entries.</span>
    <span class="doccomment">/// - The check for key equality will catch these.</span>
    <span class="doccomment">/// - This only happens if there is at least 1 true match.</span>
    <span class="doccomment">/// - The chance of this happening is very low (&lt; 1% chance per byte).</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">match_byte</span>(<span class="self">self</span>, <span class="ident">byte</span>: <span class="ident">u8</span>) -&gt; <span class="ident">BitMask</span> {
        <span class="comment">// This algorithm is derived from</span>
        <span class="comment">// https://graphics.stanford.edu/~seander/bithacks.html##ValueInWord</span>
        <span class="kw">let</span> <span class="ident">cmp</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span> <span class="op">^</span> <span class="ident">repeat</span>(<span class="ident">byte</span>);
        <span class="ident">BitMask</span>((<span class="ident">cmp</span>.<span class="ident">wrapping_sub</span>(<span class="ident">repeat</span>(<span class="number">0x01</span>)) <span class="op">&amp;</span> <span class="op">!</span><span class="ident">cmp</span> <span class="op">&amp;</span> <span class="ident">repeat</span>(<span class="number">0x80</span>)).<span class="ident">to_le</span>())
    }

    <span class="doccomment">/// Returns a `BitMask` indicating all bytes in the group which are</span>
    <span class="doccomment">/// `EMPTY`.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">match_empty</span>(<span class="self">self</span>) -&gt; <span class="ident">BitMask</span> {
        <span class="comment">// If the high bit is set, then the byte must be either:</span>
        <span class="comment">// 1111_1111 (EMPTY) or 1000_0000 (DELETED).</span>
        <span class="comment">// So we can just check if the top two bits are 1 by ANDing them.</span>
        <span class="ident">BitMask</span>((<span class="self">self</span>.<span class="number">0</span> <span class="op">&amp;</span> (<span class="self">self</span>.<span class="number">0</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">1</span>) <span class="op">&amp;</span> <span class="ident">repeat</span>(<span class="number">0x80</span>)).<span class="ident">to_le</span>())
    }

    <span class="doccomment">/// Returns a `BitMask` indicating all bytes in the group which are</span>
    <span class="doccomment">/// `EMPTY` or `DELETED`.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">match_empty_or_deleted</span>(<span class="self">self</span>) -&gt; <span class="ident">BitMask</span> {
        <span class="comment">// A byte is EMPTY or DELETED iff the high bit is set</span>
        <span class="ident">BitMask</span>((<span class="self">self</span>.<span class="number">0</span> <span class="op">&amp;</span> <span class="ident">repeat</span>(<span class="number">0x80</span>)).<span class="ident">to_le</span>())
    }

    <span class="doccomment">/// Returns a `BitMask` indicating all bytes in the group which are full.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">match_full</span>(<span class="self">self</span>) -&gt; <span class="ident">BitMask</span> {
        <span class="self">self</span>.<span class="ident">match_empty_or_deleted</span>().<span class="ident">invert</span>()
    }

    <span class="doccomment">/// Performs the following transformation on all bytes in the group:</span>
    <span class="doccomment">/// - `EMPTY =&gt; EMPTY`</span>
    <span class="doccomment">/// - `DELETED =&gt; EMPTY`</span>
    <span class="doccomment">/// - `FULL =&gt; DELETED`</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">convert_special_to_empty_and_full_to_deleted</span>(<span class="self">self</span>) -&gt; <span class="self">Self</span> {
        <span class="comment">// Map high_bit = 1 (EMPTY or DELETED) to 1111_1111</span>
        <span class="comment">// and high_bit = 0 (FULL) to 1000_0000</span>
        <span class="comment">//</span>
        <span class="comment">// Here&#39;s this logic expanded to concrete values:</span>
        <span class="comment">//   let full = 1000_0000 (true) or 0000_0000 (false)</span>
        <span class="comment">//   !1000_0000 + 1 = 0111_1111 + 1 = 1000_0000 (no carry)</span>
        <span class="comment">//   !0000_0000 + 0 = 1111_1111 + 0 = 1111_1111 (no carry)</span>
        <span class="kw">let</span> <span class="ident">full</span> <span class="op">=</span> <span class="op">!</span><span class="self">self</span>.<span class="number">0</span> <span class="op">&amp;</span> <span class="ident">repeat</span>(<span class="number">0x80</span>);
        <span class="ident">Group</span>(<span class="op">!</span><span class="ident">full</span> <span class="op">+</span> (<span class="ident">full</span> <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">7</span>))
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="hashbrown" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>